#!/bin/sh

build=build
compiler=gcc
ld=ld
opt="-Wall -O -fstrength-reduce -fomit-frame-pointer -nostdinc -fno-builtin -I./kernel/include -c -fno-strict-aliasing -fno-common -fno-stack-protector"

echo "Building Isaax OS!"
echo "==========="

# Build C files

$compiler $opt -o $build/main.o ./kernel/main.c 
$compiler $opt -o $build/console.o ./kernel/console.c

# Build ASM files
nasm -f elf ./kernel/loader.asm -o $build/loader.o

# Link 
$ld -T linker.ld $build/*.o

# Put in floppy

sh ./mountingpoint.sh
